#include <cstdio>
#include <dlfcn.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define RTLD_DELAY 0x00001

typedef void (*testfunc)();

int main()
{
    printf("hello from app1!\n");

    char buff[FILENAME_MAX];
    size_t len = strlen(getcwd(buff, FILENAME_MAX));
    strcpy(buff + len, "/libsayhello.so");

    void *pHandle = dlopen(buff, RTLD_DELAY);
    if (pHandle == nullptr)
    {
        char *pError = dlerror();
        printf("dlopen == %s\n", pError);
        printf("pHandle == nullptr\n");
        return 1;
    }

    do
    {
        void* pFunc = dlsym(pHandle, "test");
        if (pFunc == nullptr)
        {
            printf("pFunc == nullptr\n");
            break;
        }

        testfunc proxyFunc = (testfunc)pFunc;

        proxyFunc();
    } while (false);

    if (pHandle != nullptr)
    {
        dlclose(pHandle);
        pHandle = nullptr;
    }

    return 0;
}